' ***********************************************************************
' Assembly         : Ioc
' Author           : Tim Ford
' Created          : 10-02-2013
'
' Last Modified By : Tim Ford
' Last Modified On : 10-02-2013
' ***********************************************************************
' <copyright file="CacheMethodInvalidateMethodNameAttribute.vb" company="Red Baron Solutions">
'     Red Baron Solutions. All rights reserved.
' </copyright>
' <summary></summary>
' ***********************************************************************


Namespace Ioc.Attributes
    ''' <summary>
    ''' 	
    ''' </summary>
    <AttributeUsage(AttributeTargets.Method Or AttributeTargets.Property, AllowMultiple:=False)> _
    Public NotInheritable Class CacheMethodInvalidateMethodNameAttribute
        Inherits Attribute
        ''' <summary>
        ''' Initializes a new instance of the <see cref="CacheMethodInvalidateMethodNameAttribute" /> class.	
        ''' </summary>
        ''' <param name="methodName">Name of the method.</param>
        ''' <remarks></remarks>
        Public Sub New(methodName As String)
            m_MethodName = methodName
        End Sub

        ''' <summary>
        ''' Gets the name of the method.	
        ''' </summary>
        ''' <value>The name of the method.</value>
        ''' <remarks></remarks>
        Public ReadOnly Property MethodName() As String
            Get
                Return m_MethodName
            End Get
        End Property
        Private ReadOnly m_MethodName As String
    End Class
End Namespace
