' ***********************************************************************
' Assembly         : Ioc
' Author           : Tim Ford
' Created          : 10-02-2013
'
' Last Modified By : Tim Ford
' Last Modified On : 10-02-2013
' ***********************************************************************
' <copyright file="MethodCacheTimeAttribute.vb" company="Red Baron Solutions">
'     Red Baron Solutions. All rights reserved.
' </copyright>
' <summary></summary>
' ***********************************************************************


Namespace Ioc.Attributes
    ''' <summary>
    ''' 	
    ''' </summary>
    <AttributeUsage(AttributeTargets.Method Or AttributeTargets.Property, AllowMultiple:=False)> _
    Public NotInheritable Class MethodCacheTimeAttribute
        Inherits Attribute

        ''' <summary>
        ''' Initializes a new instance of the <see cref="MethodCacheTimeAttribute" /> class.	
        ''' </summary>
        ''' <param name="timeSpan">The time span.</param>
        ''' <remarks></remarks>
        Public Sub New(timeSpan As TimeSpan)
            m_TimeSpan = timeSpan
        End Sub

        ''' <summary>
        ''' Gets the time span.	
        ''' </summary>
        ''' <value></value>
        ''' <remarks></remarks>
        Public ReadOnly Property TimeSpan() As TimeSpan
            Get
                Return m_TimeSpan
            End Get
        End Property
        Private ReadOnly m_TimeSpan As TimeSpan


    End Class
End Namespace
