' ***********************************************************************
' Assembly         : Ioc
' Author           : Tim Ford
' Created          : 10-02-2013
'
' Last Modified By : Tim Ford
' Last Modified On : 10-02-2013
' ***********************************************************************
' <copyright file="SingleInstance.vb" company="Red Baron Solutions">
'     Red Baron Solutions. All rights reserved.
' </copyright>
' <summary></summary>
' ***********************************************************************
Namespace Ioc
    ''' <summary>
    ''' 	
    ''' </summary>
    Friend Class SingleInstance
        Inherits BaseFactory

 
        ''' <summary>
        ''' Initializes a new instance of the <see cref="SingleInstance" /> class.	
        ''' </summary>
        ''' <param name="instance">The instance.</param>
        ''' <remarks></remarks>
        Public Sub New(instance As Object)
            m_Instance = instance
        End Sub
        Private ReadOnly m_Instance As Object

        ''' <summary>
        ''' Gets the object.	
        ''' </summary>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Overrides Function GetObject() As Object
            Return m_Instance
        End Function
    End Class

    Friend Class SingleInstance(Of T As New)
        Inherits BaseFactory
        Private Sub New()
            m_Lazy = New Lazy(Of T)
        End Sub
        Private m_Lazy As Lazy(Of T)

        Public Overrides Function GetObject() As Object
            Return m_Lazy.Value
        End Function
    End Class
End Namespace